(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPowerbox;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-ui-powerbox":{"powerbox-server.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-ui-powerbox/powerbox-server.js                                                                  //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
var Crypto = Npm.require("crypto");                                                                                   // 17
var Capnp = Npm.require("capnp");                                                                                     // 18
var Powerbox = Capnp.importSystem("sandstorm/powerbox.capnp");                                                        // 19
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                              // 20
                                                                                                                      //
// TODO(cleanup): lift this out of a package so it can share with async-helpers.js                                    //
var Future = Npm.require("fibers/future");                                                                            // 23
var promiseToFuture = function promiseToFuture(promise) {                                                             // 24
  var result = new Future();                                                                                          // 25
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                          // 26
  return result;                                                                                                      // 27
};                                                                                                                    // 28
                                                                                                                      //
var waitPromise = function waitPromise(promise) {                                                                     // 30
  return promiseToFuture(promise).wait();                                                                             // 31
};                                                                                                                    // 32
                                                                                                                      //
function encodePowerboxDescriptor(desc) {                                                                             // 34
  return Capnp.serializePacked(Powerbox.PowerboxDescriptor, desc).toString("base64").replace(/\+/g, "-").replace(/\//g, "_");
}                                                                                                                     // 39
                                                                                                                      //
Meteor.methods({                                                                                                      // 41
  newFrontendRef: function newFrontendRef(sessionId, frontendRefRequest) {                                            // 42
    // Completes a powerbox request for a frontendRef capability.                                                     //
    check(sessionId, String);                                                                                         // 44
    // frontendRefRequest is type-checked by frontendRefRegistry.validate(), below.                                   //
                                                                                                                      //
    var db = this.connection.sandstormDb;                                                                             // 47
    var frontendRefRegistry = this.connection.frontendRefRegistry;                                                    // 48
                                                                                                                      //
    var session = db.collections.sessions.findOne({ _id: sessionId, userId: this.userId || { $exists: false } });     // 50
    if (!session) {                                                                                                   // 52
      throw new Meteor.Error(403, "Invalid session ID");                                                              // 53
    }                                                                                                                 // 54
                                                                                                                      //
    var _frontendRefRegistry$ = frontendRefRegistry.validate(db, session, frontendRefRequest);                        // 42
                                                                                                                      //
    var descriptor = _frontendRefRegistry$.descriptor;                                                                // 42
    var requirements = _frontendRefRegistry$.requirements;                                                            // 42
    var frontendRef = _frontendRefRegistry$.frontendRef;                                                              // 42
                                                                                                                      //
    descriptor = encodePowerboxDescriptor(descriptor);                                                                // 58
                                                                                                                      //
    var grainId = session.grainId;                                                                                    // 60
    var apiTokenOwner = {                                                                                             // 61
      clientPowerboxRequest: {                                                                                        // 62
        grainId: grainId,                                                                                             // 63
        introducerIdentity: session.identityId,                                                                       // 64
        sessionId: session._id                                                                                        // 65
      }                                                                                                               // 62
    };                                                                                                                // 61
                                                                                                                      //
    var cap = frontendRefRegistry.create(db, frontendRef, requirements);                                              // 69
    var sturdyRef = waitPromise(cap.save(apiTokenOwner)).sturdyRef.toString();                                        // 70
    cap.close();                                                                                                      // 71
    return { sturdyRef: sturdyRef, descriptor: descriptor };                                                          // 72
  },                                                                                                                  // 73
  fulfillUiViewRequest: function fulfillUiViewRequest(sessionId, identityId, grainId, petname, roleAssignment, ownerGrainId) {
    var db = this.connection.sandstormDb;                                                                             // 76
    check(sessionId, String);                                                                                         // 77
    check(identityId, String);                                                                                        // 78
    check(grainId, String);                                                                                           // 79
    check(roleAssignment, db.roleAssignmentPattern);                                                                  // 80
    check(petname, String);                                                                                           // 81
    check(ownerGrainId, String);                                                                                      // 82
                                                                                                                      //
    if (!this.userId || !db.userHasIdentity(this.userId, identityId)) {                                               // 84
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                              // 85
    }                                                                                                                 // 86
                                                                                                                      //
    var provider = {                                                                                                  // 88
      identityId: identityId,                                                                                         // 89
      accountId: this.userId                                                                                          // 90
    };                                                                                                                // 88
                                                                                                                      //
    var title = db.userGrainTitle(grainId, this.userId, identityId);                                                  // 93
                                                                                                                      //
    var descriptor = encodePowerboxDescriptor({                                                                       // 95
      tags: [{ id: Grain.UiView.typeId,                                                                               // 96
        value: Capnp.serialize(Grain.UiView.PowerboxTag, { title: title })                                            // 98
      }]                                                                                                              // 97
    });                                                                                                               // 95
                                                                                                                      //
    var owner = {                                                                                                     // 103
      clientPowerboxRequest: {                                                                                        // 104
        grainId: ownerGrainId,                                                                                        // 105
        introducerIdentity: identityId,                                                                               // 106
        sessionId: sessionId                                                                                          // 107
      }                                                                                                               // 104
    };                                                                                                                // 103
                                                                                                                      //
    var result = SandstormPermissions.createNewApiToken(db, provider, grainId, petname, roleAssignment, owner);       // 111
                                                                                                                      //
    return {                                                                                                          // 114
      sturdyRef: result.token,                                                                                        // 115
      descriptor: descriptor                                                                                          // 116
    };                                                                                                                // 114
  }                                                                                                                   // 118
});                                                                                                                   // 41
                                                                                                                      //
var PowerboxOption = function () {                                                                                    //
  function PowerboxOption(fields) {                                                                                   // 122
    _classCallCheck(this, PowerboxOption);                                                                            // 122
                                                                                                                      //
    _.extend(this, fields);                                                                                           // 123
  }                                                                                                                   // 124
                                                                                                                      //
  PowerboxOption.prototype.intersect = function intersect(other) {                                                    //
    // Intersect two options with the same ID. Used when combining matches from multiple tags                         //
    // in the same descriptor. The tags are a conjunction.                                                            //
    //                                                                                                                //
    // Returns true if there was any overlap, or false if there was no overlap and therefore the                      //
    // option should be dropped.                                                                                      //
    //                                                                                                                //
    // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                       //
                                                                                                                      //
    if (other._id != this._id) {                                                                                      // 135
      throw new Error("can only merge options with the same ID");                                                     // 136
    }                                                                                                                 // 137
                                                                                                                      //
    if (other.grainId) {                                                                                              // 139
      if (this.uiView && !other.uiView) delete this.uiView;                                                           // 140
      if (this.hostedObject && !other.hostedObject) delete this.hostedObject;                                         // 141
      return !!(this.uiView || this.hostedObject);                                                                    // 142
    } else if ((this.frontendRef || {}).verifiedEmail) {                                                              // 143
      // Try to hint which verifierId matched.                                                                        //
      if (this.frontendRef.verifiedEmail.verifierId) {                                                                // 145
        if (other.frontendRef.verifiedEmail.verifierId) {                                                             // 146
          // Can't match multiple verifiers at once.                                                                  //
          return false;                                                                                               // 148
        }                                                                                                             // 149
      } else if (other.frontendRef.verifiedEmail.verifierId) {                                                        // 150
        // One request did not specify any verifierId, the other did, and both matched, so use                        //
        // the verifierId.                                                                                            //
        this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                       // 153
      }                                                                                                               // 154
                                                                                                                      //
      return true;                                                                                                    // 156
    } else {                                                                                                          // 157
      // No intersection logic needed for other types.                                                                //
      return true;                                                                                                    // 159
    }                                                                                                                 // 160
  };                                                                                                                  // 161
                                                                                                                      //
  PowerboxOption.prototype.union = function union(other) {                                                            //
    // Union two options with the same ID. Used when combining matches from multiple descriptors.                     //
    // The descriptors are a disjunction.                                                                             //
    //                                                                                                                //
    // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                       //
                                                                                                                      //
    if (other._id != this._id) {                                                                                      // 169
      throw new Error("can only merge options with the same ID");                                                     // 170
    }                                                                                                                 // 171
                                                                                                                      //
    if (other.grainId) {                                                                                              // 173
      if (!this.uiView && other.uiView) this.uiView = other.uiView;                                                   // 174
      if (!this.hostedObject && other.hostedObject) this.hostedObject = other.hostedObject;                           // 175
    } else if ((this.frontendRef || {}).verifiedEmail) {                                                              // 176
      // If this doesn't have a verifierId but other does, copy it over.                                              //
      if (!this.frontendRef.verifiedEmail.verifierId && other.frontendRef.verifiedEmail.verifierId) {                 // 178
        this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                       // 180
      }                                                                                                               // 181
    }                                                                                                                 // 182
  };                                                                                                                  // 183
                                                                                                                      //
  PowerboxOption.prototype.subtract = function subtract(other) {                                                      //
    // Remove `other` from this. Used when `other` is a match deemed unacceptable. Returns true                       //
    // if there's anything left, false otherwise.                                                                     //
                                                                                                                      //
    if (other._id != this._id) {                                                                                      // 189
      throw new Error("can only merge options with the same ID");                                                     // 190
    }                                                                                                                 // 191
                                                                                                                      //
    if (other.grainId) {                                                                                              // 193
      if (this.uiView && other.uiView) delete this.uiView;                                                            // 194
      if (this.hostedObject && other.hostedObject) delete this.hostedObject;                                          // 195
      return !!(this.uiView || this.hostedObject);                                                                    // 196
    } else {                                                                                                          // 197
      return false;                                                                                                   // 198
    }                                                                                                                 // 199
  };                                                                                                                  // 200
                                                                                                                      //
  return PowerboxOption;                                                                                              //
}();                                                                                                                  //
                                                                                                                      //
function registerUiViewQueryHandler(frontendRefRegistry) {                                                            // 203
  // TODO(cleanup): Maybe this belongs in a different file? But where?                                                //
                                                                                                                      //
  frontendRefRegistry.register({                                                                                      // 206
    typeId: Grain.UiView.typeId,                                                                                      // 207
                                                                                                                      //
    query: function query(db, userId, value) {                                                                        // 209
      if (!userId) return [];                                                                                         // 210
                                                                                                                      //
      // TODO(someday): Allow `value` to specify app IDs to filter for.                                               //
                                                                                                                      //
      var sharedGrainIds = db.userApiTokens(userId).map(function (token) {                                            // 214
        return token.grainId;                                                                                         // 214
      });                                                                                                             // 214
      var ownedGrainIds = db.userGrains(userId).map(function (grain) {                                                // 215
        return grain._id;                                                                                             // 215
      });                                                                                                             // 215
                                                                                                                      //
      return _.uniq(sharedGrainIds.concat(ownedGrainIds)).map(function (grainId) {                                    // 217
        return new PowerboxOption({                                                                                   // 218
          _id: "grain-" + grainId,                                                                                    // 219
          grainId: grainId,                                                                                           // 220
          uiView: {},                                                                                                 // 221
          cardTemplate: "grainPowerboxCard",                                                                          // 222
          configureTemplate: "uiViewPowerboxConfiguration"                                                            // 223
        });                                                                                                           // 218
      });                                                                                                             // 225
    }                                                                                                                 // 226
  });                                                                                                                 // 206
}                                                                                                                     // 228
                                                                                                                      //
Meteor.publish("powerboxOptions", function (requestId, descriptorList) {                                              // 230
  var _this = this;                                                                                                   // 230
                                                                                                                      //
  // Performs a powerbox query, returning options to present to the user in the powerbox.                             //
  // `descriptorList` is an array of `PowerboxDescriptor`s, each individually serialized in                           //
  // packed format and base64-encoded. The publish populates a pseudo-collection called                               //
  // `powerboxOptions`. Each item has the following fields:                                                           //
  //                                                                                                                  //
  //   _id: Unique identifier string.                                                                                 //
  //      TODO(soon): This ID string is often a human-readable name like "frontendref-ipinterface"                    //
  //        and is only guaranteed to be unique because we currently don't allow a client to have                     //
  //        multiple powerbox requests active at the same time. We should strengthen this uniqueness                  //
  //        guarentee, possibly by incorporating `requestId`. Note, however, that Meteor requires `_id`               //
  //        to be either a string or an `ObjectID`.                                                                   //
  //   requestId: The value of `requestId` that was passed in when subscribing.                                       //
  //   matchQuality: "preferred" or "acceptable" ("unacceptable" options aren't returned).                            //
  //   frontendRef: If present, selecting this option means creating a simple frontendRef. The                        //
  //       field value should be passed back to the method `newFrontendRef` verbatim. The format                      //
  //       of the field is the same as ApiTokens.frontendRef.                                                         //
  //   grainId: If present, this option selects a grain to satisfy the request. One or both of                        //
  //       `uiView` and `hostedObject` will be present. Mutually exclusive with `frontendRef`.                        //
  //   uiView: If present, this option creates a UiView for a grain. The UI should allow the user                     //
  //       to choose a role to grant. Only present when `grainId` is also present. `uiView` is an                     //
  //       object with the fields:                                                                                    //
  //     TODO(someday): Some sort of indication of what options the powerbox should give the user                     //
  //         as far as which permissions to grant? Unclear if any app would ever want to specify                      //
  //         permissions when requesting a plain UiView.                                                              //
  //   hostedObject: If present, this grain advertises that it publishes capabilities that might                      //
  //       match the query. If selected, a request session to the grain embedded should be shown                      //
  //       embedded in the powerbox and the same request should be passed to it. Only present when                    //
  //       `grainId` is also present. `hostedObject`, when present, is (for now) an empty object.                     //
  //   cardTemplate: Names the client-side template to use to display this powerbox option. The                       //
  //       template's data context will be a "card" object as returned by                                             //
  //       SandstormPowerboxRequest.filteredCardData(). Also, the template definition (in client                      //
  //       code) may have a static method `powerboxIconSrc` which takes the card as a parameter                       //
  //       and returns the URL of the icon to display next to the option.                                             //
  //   configureTemplate: If selecting this option should then show a further dialog, names the                       //
  //       client-side template for that dialog.                                                                      //
  //   ...: Other fields may be added for consumption by the client-side template.                                    //
                                                                                                                      //
  var results = {};                                                                                                   // 268
  var db = this.connection.sandstormDb;                                                                               // 269
  var frontendRefRegistry = this.connection.frontendRefRegistry;                                                      // 270
                                                                                                                      //
  if (descriptorList.length > 0) {                                                                                    // 272
    var descriptorMatches = descriptorList.map(function (packedDescriptor) {                                          // 273
      // Decode the descriptor.                                                                                       //
      // TODO(now): Also single-segment? Canonical?                                                                   //
                                                                                                                      //
      // Note: Node's base64 decoder also accepts URL-safe base64, so no need to translate.                           //
      var descriptor = Capnp.parse(Powerbox.PowerboxDescriptor, new Buffer(packedDescriptor, "base64"), { packed: true });
                                                                                                                      //
      if (!descriptor.tags || descriptor.tags.length === 0) return {};                                                // 283
                                                                                                                      //
      // Expand each tag into a match map.                                                                            //
      var tagMatches = descriptor.tags.map(function (tag) {                                                           // 286
        var result = {};                                                                                              // 287
                                                                                                                      //
        frontendRefRegistry.query(db, _this.userId, tag).forEach(function (option) {                                  // 289
          result[option._id] = new PowerboxOption(option);                                                            // 290
        });                                                                                                           // 291
                                                                                                                      //
        return result;                                                                                                // 293
      });                                                                                                             // 294
                                                                                                                      //
      // Intersect two tags' matches.                                                                                 //
      var matches = tagMatches.reduce(function (a, b) {                                                               // 297
        for (var id in a) {                                                                                           // 298
          if (id in b) {                                                                                              // 299
            if (!a[id].intersect(b[id])) {                                                                            // 300
              // Empty intersection.                                                                                  //
              delete a[id];                                                                                           // 302
            }                                                                                                         // 303
          } else {                                                                                                    // 304
            // This match only exists in a, not b, so delete it.                                                      //
            delete a[id];                                                                                             // 306
          }                                                                                                           // 307
        }                                                                                                             // 308
                                                                                                                      //
        return a;                                                                                                     // 310
      });                                                                                                             // 311
                                                                                                                      //
      return { descriptor: descriptor, matches: matches };                                                            // 313
    });                                                                                                               // 314
                                                                                                                      //
    // TODO(someday): The implementation of matchQuality here is not quite right. In theory, we're                    //
    //   supposed to compare descriptors to determine which ones are more specific than which                         //
    //   others, and prefer the most-specific match. For now, though, I've implemented a heuristic:                   //
    //   consider each descriptor in order. If it is "unacceptable", have it cancel out any                           //
    //   matches seen previously. Otherwise, take the maximum match quality. This will usually                        //
    //   produce the same results as long as "unacceptable" descriptors are placed last in the                        //
    //   list.                                                                                                        //
                                                                                                                      //
    var matches = descriptorMatches.reduce(function (finalMatches, clause) {                                          // 324
      if (clause.matchQuality === "unacceptable") {                                                                   // 325
        // Remove b's matches from a.                                                                                 //
        for (var id in clause.matches) {                                                                              // 327
          if (id in finalMatches) {                                                                                   // 328
            if (!finalMatches[id].subtract(clause.matches[id])) {                                                     // 329
              delete finalMatches[id];                                                                                // 330
            }                                                                                                         // 331
          }                                                                                                           // 332
        }                                                                                                             // 333
                                                                                                                      //
        return finalMatches;                                                                                          // 335
      } else {                                                                                                        // 336
        for (var _id in clause.matches) {                                                                             // 337
          if (_id in finalMatches) {                                                                                  // 338
            finalMatches[_id].union(clause.matches[_id]);                                                             // 339
          } else {                                                                                                    // 340
            finalMatches[_id] = clause.matches[_id];                                                                  // 341
          }                                                                                                           // 342
                                                                                                                      //
          if (clause.matchQuality === "preferred") {                                                                  // 344
            finalMatches[_id].matchQuality = "preferred";                                                             // 345
          }                                                                                                           // 346
        }                                                                                                             // 347
                                                                                                                      //
        return finalMatches;                                                                                          // 349
      }                                                                                                               // 350
    }, {});                                                                                                           // 351
                                                                                                                      //
    for (var id in matches) {                                                                                         // 353
      if (!matches[id].matchQuality) {                                                                                // 354
        matches[id].matchQuality = "acceptable";                                                                      // 355
      }                                                                                                               // 356
                                                                                                                      //
      matches[id].requestId = requestId;                                                                              // 358
      this.added("powerboxOptions", id, matches[id]);                                                                 // 359
    }                                                                                                                 // 360
  }                                                                                                                   // 361
                                                                                                                      //
  // TODO(someday): Make reactive? Seems annoying.                                                                    //
                                                                                                                      //
  this.ready();                                                                                                       // 365
});                                                                                                                   // 366
                                                                                                                      //
SandstormPowerbox = { registerUiViewQueryHandler: registerUiViewQueryHandler };                                       // 368
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-ui-powerbox/powerbox-server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-ui-powerbox'] = {}, {
  SandstormPowerbox: SandstormPowerbox
});

})();

//# sourceMappingURL=sandstorm-ui-powerbox.js.map
